@echo off
setlocal
mode con: cols=39 lines=19
goto :variable_block

:: Microsoft Windows Batch Script
::
:: Name: Screen Setting Patch
:: Version: 0.1
:: Author: Michal Millar
:: https://github.com/michalmillar
:: http://www.bolis.com
::
:: Exe made with Bat To Exe Converter
:: http://www.f2ko.de/en/b2e.php
::
:: Hex editing done with XVI32
:: http://www.chmaas.handshake.de/delphi/freeware/xvi32/xvi32.htm
:: 
:: Common Hex Values
:: http://www.wsgf.org/article/common-hex-values
:: 
:: 
:: Remember to set your default variables!
:: 

:variable_block
set current_path=%~dp0

cd %current_path%

set hex_edit_prog=XVI32.exe
set hex_edit_script=patch.xsc
set file_to_modify=mgsvtpp.exe
set default_ratio_value="39 8E E3 3F"
set default_ratio_label=(16:9)
set label_ratio_value=%default_ratio_label%
set default_fov_value="00 00 B4 42"
set default_fov_label=(90)
set label_fov_value=%default_fov_label%
set clean_files=XVI32.ini


:warning_message
cls
color 4F
echo.
echo. ============== WARNING ==============
echo.
echo.
echo. -------------------------------------
echo. This script is intended to modify
echo. an executable file. As such, it is
echo. very possible you could corrupt
echo. your program by using this. Please
echo. be careful and do your research
echo. before running this. 
echo. -------------------------------------
echo.
echo.
echo.
echo. ============== WARNING ==============
echo. 
echo.
pause

color 9F

:main_menu
cls

echo.
echo. ============= Main Menu =============
echo. -------------------------------------
echo. 1.  Choose Aspect Ratio
echo. -------------------------------------
echo. 2.  Choose FOV size
echo. -------------------------------------
echo. 3.  Patch Game
echo. -------------------------------------
echo.               Advanced
echo. -------------------------------------
echo. 4.  Set Custom HEX Values
echo. -------------------------------------
echo.
echo. Aspect: %label_ratio_value% FOV: %label_fov_value%
echo. ========= Press 'q' to Quit =========
echo.

set choice=
set /p choice="Please select an option: " 
echo.

if /i '%choice%'=='1' goto menu_ratio
if /i '%choice%'=='2' goto menu_fov
if /i '%choice%'=='3' goto menu_patch
if /i '%choice%'=='4' goto menu_advanced
if /i '%choice%'=='q' goto quit_prog

cls

echo.
echo.
echo. ========== Invalid Choice ===========
echo.
echo.
echo.
echo.
echo.
echo. -------------------------------------
echo. Please select a number from the Main
echo. Menu [1-4] or select 'q' to quit.
echo. -------------------------------------
echo.
echo.
echo.
echo.
echo. ===== Press Any Key to Continue =====
echo.
echo.

pause >nul

echo.
goto main_menu

:menu_ratio
cls

echo.
echo. ======= Choose Aspect Ratio =========
echo.
echo.  Default is %default_ratio_label%
echo.  1.  (5:4)      ie, (1280x1024)
echo.  2.  (4:3)      ie, (1600x1200)
echo.  3.  (16:10)    ie, (1680x1050)
echo.  4.  (16:9)     ie, (1920x1080)
echo.  5.  (21:9)     ie, (2560x1080)
echo.  6.  (2.39:1)   ie, (3440x1440)
echo.  7.  (3x5:4)    ie, (3840x1024)
echo.  8.  (3x4:3)    ie, (4800x1200)
echo.  9.  (3x16:10)  ie, (5040x1050)
echo.  10. (3x16:9)   ie, (5760x1080)
echo.
echo. ==== Press 'm' to Return to Menu ====
echo.

set ratio_choice=
set /p ratio_choice="Please select an option: "
echo.

if /i '%ratio_choice%'=='1' goto ratio_select_1
if /i '%ratio_choice%'=='2' goto ratio_select_2
if /i '%ratio_choice%'=='3' goto ratio_select_3
if /i '%ratio_choice%'=='4' goto ratio_select_4
if /i '%ratio_choice%'=='5' goto ratio_select_5
if /i '%ratio_choice%'=='6' goto ratio_select_6
if /i '%ratio_choice%'=='7' goto ratio_select_7
if /i '%ratio_choice%'=='8' goto ratio_select_8
if /i '%ratio_choice%'=='9' goto ratio_select_9
if /i '%ratio_choice%'=='10' goto ratio_select_10
if /i '%ratio_choice%'=='m' goto main_menu

cls

echo.
echo.
echo. ========== Invalid Choice ===========
echo.
echo.
echo.
echo.
echo. -------------------------------------
echo. Please select a number from the Ratio
echo. Menu [1-9] or select 'm' to return to
echo. the Main Menu.
echo. -------------------------------------
echo.
echo.
echo.
echo.
echo. ===== Press Any Key to Continue =====
echo.
echo.

pause >nul

goto menu_ratio


:ratio_select_1
set label_ratio_value=(5:4)
set new_ratio_value="00 00 A0 3F"
goto main_menu


:ratio_select_2
set label_ratio_value=(4:3)
set new_ratio_value="AB AA AA 3F"
goto main_menu


:ratio_select_3
set label_ratio_value=(16:10)
set new_ratio_value="CD CC CC 3F"
goto main_menu


:ratio_select_4
set label_ratio_value=(16:9)
set new_ratio_value="39 8E E3 3F"
goto main_menu


:ratio_select_5
set label_ratio_value=(21:9)
set new_ratio_value="26 B4 17 40"
goto main_menu


:ratio_select_6
set label_ratio_value=(2.39:1)
set new_ratio_value="8E E3 18 40"
goto main_menu


:ratio_select_7
set label_ratio_value=(3x5:4)
set new_ratio_value="00 00 70 40"
goto main_menu


:ratio_select_8
set label_ratio_value=(3x4:3)
set new_ratio_value="00 00 80 40"
goto main_menu


:ratio_select_9
set label_ratio_value=(3x16:10)
set new_ratio_value="9A 99 99 40"
goto main_menu


:ratio_select_10
set label_ratio_value=(3x16:9)
set new_ratio_value="AB AA AA 40"
goto main_menu


:menu_fov
cls

echo.
echo. ========= Select FOV Amount =========
echo.
echo.  Default is %default_fov_label% degrees
echo.
echo.  1.  (85)
echo.  2.  (90)
echo.  3.  (95)
echo.  4.  (100)
echo.  5.  (105)
echo.  6.  (110)
echo.  7.  (115)
echo.  8.  (120)
echo.
echo.
echo. ==== Press 'm' to Return to Menu ====
echo.

set fov_choice=
set /p fov_choice="Please select an option: "
echo.

if /i '%fov_choice%'=='1' goto fov_select_1
if /i '%fov_choice%'=='2' goto fov_select_2
if /i '%fov_choice%'=='3' goto fov_select_3
if /i '%fov_choice%'=='4' goto fov_select_4
if /i '%fov_choice%'=='5' goto fov_select_5
if /i '%fov_choice%'=='6' goto fov_select_6
if /i '%fov_choice%'=='7' goto fov_select_7
if /i '%fov_choice%'=='8' goto fov_select_7
if /i '%fov_choice%'=='m' goto main_menu

cls

echo.
echo.
echo. ========== Invalid Choice ===========
echo.
echo.
echo.
echo.
echo. -------------------------------------
echo. Please select a number from the FOV
echo. Menu [1-7] or select 'm' to return to
echo. the Main Menu.
echo. -------------------------------------
echo.
echo.
echo.
echo.
echo. ===== Press Any Key to Continue =====
echo.
echo.

pause >nul

goto menu_fov


:fov_select_1
set label_fov_value=(85)
set new_fov_value="00 00 AA 42"
goto main_menu


:fov_select_2
set label_fov_value=(90)
set new_fov_value="00 00 B4 42"
goto main_menu


:fov_select_3
set label_fov_value=(95)
set new_fov_value="00 00 BE 42"
goto main_menu


:fov_select_4
set label_fov_value=(100)
set new_fov_value="00 00 C8 42"
goto main_menu


:fov_select_5
set label_fov_value=(105)
set new_fov_value="00 00 D2 42"
goto main_menu


:fov_select_6
set label_fov_value=(110)
set new_fov_value="00 00 DC 42"
goto main_menu


:fov_select_7
set label_fov_value=(115)
set new_fov_value="00 00 E6 42"
goto main_menu


:fov_select_8
set label_fov_value=(120)
set new_fov_value="00 00 F0 42"
goto main_menu


:menu_patch
cls

if [%default_ratio_value%] == [] goto error_need_vars
if [%new_ratio_value%] == [] goto error_need_vars
if [%default_fov_value%] == [] goto error_need_vars
if [%new_fov_value%] == [] set new_fov_value=%default_fov_value%

echo.
echo.
echo. ============ Patch Game =============
echo.
echo. 
echo.
echo.    These values will be replaced:
echo.
echo.    %default_ratio_value%
echo.    %default_fov_value%
echo.    
echo.    These values will be written:
echo.    
echo.    %new_ratio_value%
echo.    %new_fov_value%
echo.
echo. ===== Press Any Key to Proceed ======
echo.
echo.

pause >nul

cls

echo.
echo.
echo. ============ Patch Game =============
echo.
echo. 
echo.
echo.    These values will be replaced:
echo.
echo.    %default_ratio_value%
echo.    %default_fov_value%
echo.    
echo.    These values will be written:
echo.    
echo.    %new_ratio_value%
echo.    %new_fov_value%
echo.
echo. ===== Patching. Please Wait... ======
echo.
echo.

copy "%file_to_modify%" "%file_to_modify%.bak" >nul

start /wait %hex_edit_prog% %file_to_modify% /S=%hex_edit_script% %default_ratio_value% %new_ratio_value% %default_fov_value% %new_fov_value%

for %%i in (%clean_files%) do del %clean_files%

goto menu_finished

:menu_finished
cls

echo.
echo.
echo. ============ Patch Game =============
echo.
echo.          ------------------
echo.          Patch Run Complete
echo.          ------------------
echo.
echo.    
echo.    
echo.    If you didn't see any errors
echo.    then these values were written:
echo.    
echo.    %new_ratio_value%
echo.    %new_fov_value%
echo.
echo. ===== Press Any Key to Proceed ======
echo.
echo.
pause >nul

goto quit_prog

:error_need_vars
cls

echo.
echo.
echo. ========== Invalid Choice ===========
echo.
echo.
echo.
echo.
echo. -------------------------------------
echo. You need to select proper settings
echo. before the program can be patched.
echo. -------------------------------------
echo. 
echo.
echo.
echo.
echo.
echo. ===== Press Any Key to Continue =====
echo.
echo.
pause > nul

goto main_menu


:menu_advanced
cls

echo.
echo. ========== Enter Hex Value ==========
echo.
echo. -------------------------------------
echo. Here you can enter custom values to
echo. be patched into your program. Be 
echo. extremely careful as entering an
echo. incompatible value can corrupt your
echo. -------------------------------------
echo.
echo. Format your hex string with a space
echo. between each bit. Example:
echo.
echo.             00 00 00 00
echo.
echo. =====================================
echo.

set custom_ratio_value=
set /p custom_ratio_value="Enter desired aspect ratio: "

cls

echo.
echo. ========== Enter Hex Value ==========
echo.
echo. -------------------------------------
echo. Here you can enter custom values to
echo. be patched into your program. Be 
echo. extremely careful as entering an
echo. incompatible value can corrupt your
echo. -------------------------------------
echo.
echo. Format your hex string with a space
echo. between each bit. Example:
echo.
echo.             00 00 00 00
echo.
echo. =====================================
echo.

set custom_fov_value=
set /p custom_fov_value="Enter desired fov angle: "

goto menu_advanced_check

:menu_advanced_check
cls
if "%custom_ratio_value%" == "" goto error_need_vars
if "%custom_fov_value%" == "" goto error_need_vars

echo.
echo. ========== Enter Hex Value ==========
echo.
echo. 
echo.     ------------------------------
echo.     Do these entries look correct?
echo.     ------------------------------
echo. 
echo. 
echo.     Aspect:   %custom_ratio_value%
echo.
echo.        FOV:   %custom_fov_value%
echo.
echo.
echo.
echo. =====================================
echo.

set custom_hex_check=
set /p custom_hex_check="Do these entries look correct?[y/n]: "
echo.

if /i '%custom_hex_check%'=='y' goto format_hex_var
if /i '%custom_hex_check%'=='n' goto menu_advanced

goto menu_advanced_check

:format_hex_var
set new_ratio_value="%custom_ratio_value%"
set new_fov_value="%custom_fov_value%"
set label_ratio_value=Custom
set label_fov_value=Custom

echo. %new_ratio_value%
echo. %new_fov_value%

goto main_menu

:quit_prog
cls

echo.
echo. ============= Exiting ===============
echo.
echo.
echo.
echo.
echo.
echo.      --------------------------
echo.      Thank you! Hope it worked!
echo.      --------------------------
echo.
echo.
echo.
echo.
echo.
echo. ====== Press Any Key to Exit ========
echo.
echo.

pause >nul

cls

endlocal
color 0F

exit
